package structure;

import java.io.Serializable;

public class Struct_Time_Count implements Serializable{

	long start_date		 	= 0;	//時間計測のスタート日時
	long end_date			= 0;	//時間計測のエンド日時

	long Interval_date		= 0;	//カウントした時間（タスク走数加重後）
	long all_Interval_date	= 0;	//カウントした時間
	long wait_date			= 0;	//時間計測を中断した間隔

	long pause_date			= 0;	//時間計測の一時中断した日時
	long Restart_date		= 0;	//時間計測を再開した日時
	
//	int save_execnumber		= 1;	//前回タスク走数


	//コンストラクタ
	public void Struct_Time_Count(){
	}


	public void Start(){
		//スタートの連続は無視
		if(start_date > 0){
			return;
		}	
		start_date = System.currentTimeMillis();		
		
	}

	public void StartAndPause(){
		//スタートの連続は無視
		if(start_date > 0){
			return;
		}	
		start_date 	= System.currentTimeMillis();		
		pause_date	= start_date;
	}
	
	public void End(int execnumber){
		//エンドの連続は無視
//		if(end_date > 0){
//			return;
//		}	
		
		end_date = System.currentTimeMillis();		
	
		//一時中断していない
		if(Restart_date == 0 && pause_date == 0){
			Interval_date		=	end_date - start_date;
			all_Interval_date 	=	Interval_date;
		}
		//リスタート後に終了
		else if(Restart_date > 0 ){
			if(execnumber == 1){
				Interval_date		=	Interval_date 		+ end_date - Restart_date;
			}
			else{
				Interval_date		=	Interval_date 		+ (end_date - Restart_date)/execnumber;
			}

			all_Interval_date	=	all_Interval_date 	+ end_date - Restart_date;
			Restart_date = 0;
		}
		//一時中断後に終了
		else if(pause_date > 0 ){
			wait_date = wait_date + end_date - pause_date;
			pause_date = 0;
		}


	}
	
//	public void Pause(){
//		Pause(1);
//	}
	
	public void Pause(int execnumber){
		//一時中断の連続は無視
//		if(pause_date > 0){
//			return;
//		}	
		
		pause_date = System.currentTimeMillis();

		//カウントの計算
		
		long int_date ;
		if(Restart_date == 0){
			int_date = pause_date - start_date;
		}
		else{
			int_date = pause_date - Restart_date;
		}
		
		//本来のカウントを積算
		all_Interval_date = all_Interval_date + int_date;
		
		//↓↓↓　タスク走数加重後　↓↓↓
		//タスクは読み込みだけで、しかも自身のみ
		if(execnumber == 1){
			Interval_date	=	Interval_date + int_date;
		}
		//タスクは読み込みだけで、他も存在する
		else{
			Interval_date	=	Interval_date + int_date/execnumber;
		}
		
		//リスタートから一時中断
//		if(Restart_date != 0){
			Restart_date = 0;
//		}
	}	
/*
	public void Pause(int execnumber,long lasttime){
		//一時中断の連続は無視
//		if(pause_date > 0){
//			return;
//		}	
		
		pause_date = lasttime;

		//カウントの計算
		
		long int_date ;
		if(Restart_date == 0){
			int_date = pause_date - start_date;
		}
		else{
			int_date = pause_date - Restart_date;
		}
		
		//本来のカウントを積算
		all_Interval_date = all_Interval_date + int_date;
		
		//↓↓↓　タスク走数加重後　↓↓↓
		//タスクは読み込みだけで、しかも自身のみ
		if(execnumber == 1){
			Interval_date	=	Interval_date + int_date;
		}
		//タスクは読み込みだけで、他も存在する
		else{
			Interval_date	=	Interval_date + int_date/execnumber;
		}
		
		//リスタートから一時中断
//		if(Restart_date != 0){
			Restart_date = 0;
//		}
	}		
*/	
	public void ReStart(){
		Restart_date = System.currentTimeMillis();
		wait_date = wait_date + Restart_date - pause_date;
		pause_date = 0;
	}

	
	
	
	public void ChangeExecNumber(int execnumber){
		

		//カウントの計算
		long int_date1  = System.currentTimeMillis();
		long int_date2 ;
		if(Restart_date == 0){
			int_date2 = int_date1 - start_date;
		}
		else{
			int_date2 = int_date1 - Restart_date;
		}
		
		//本来のカウントを積算
		all_Interval_date = all_Interval_date + int_date2;
		
		//↓↓↓　タスク走数加重後　↓↓↓
		//タスクは読み込みだけで、しかも自身のみ
		if(execnumber == 1){
			Interval_date	=	Interval_date + int_date2;
		}
		//タスクは読み込みだけで、他も存在する
		else{
			Interval_date	=	Interval_date + int_date2/execnumber;
		}
		
		//再リスタート
		Restart_date = int_date1;
	}		
	
	
	
	
	/*	
	public void ReStart(int execnumber){
		//書き込み走数が存在する場合はカウントオフ
		if(execnumber == 0){
			Pause(execnumber);
			return;
		}
		//リスタート⇒リスタート
		else if(pause_date == 0){

			//カウントの計算
			long int_date = 0;
			if(Restart_date == 0){
				int_date = System.currentTimeMillis() - start_date;
			}
			else{
				int_date = System.currentTimeMillis() - Restart_date;
			}
			
			//本来のカウントを積算
			all_Interval_date = all_Interval_date + int_date;

			//↓↓↓　タスク走数加重後　↓↓↓
			//タスクは読み込みだけで、しかも自身のみ
			if(execnumber == 1){
				Interval_date	=	Interval_date + int_date;
			}
			//タスクは読み込みだけで、他も存在する
			else{
				Interval_date	=	Interval_date + int_date/execnumber;
			}			
			
			Restart_date = System.currentTimeMillis();
			pause_date = 0;
		}	
		//ポーズ⇒リスタート
		else{
			Restart_date = System.currentTimeMillis();
			wait_date = wait_date + Restart_date - pause_date;
			pause_date = 0;
		}
	
	}
*/	
	
/*
	//タイマーによる更新
	public void Interval(int execnumber){
		//書き込み走数が存在する場合はカウントオフ
		if(execnumber == 0){
			long int_date ;
			if(Restart_date != 0){
				int_date = System.currentTimeMillis() - Restart_date;
			}
			else if(pause_date != 0){
				int_date = System.currentTimeMillis() - pause_date;
			}
			else{
				int_date = System.currentTimeMillis() - start_date;
			}
			wait_date = wait_date + int_date;
		}
		//前回がポーズだった場合
		else if(pause_date != 0){
			Restart_date = System.currentTimeMillis();
			wait_date = wait_date + Restart_date - pause_date;
		}
		//前回がリスタートまたはインターバルだった場合
		else{
			//カウントの計算
			long int_date ;
			if(Restart_date == 0){
				int_date = System.currentTimeMillis() - start_date;
				
			}
			else{
				int_date = System.currentTimeMillis() - Restart_date;
			}
			
			//本来のカウントを積算
			all_Interval_date = all_Interval_date + int_date;

			//↓↓↓　タスク走数加重後　↓↓↓
			//タスクは読み込みだけで、しかも自身のみ
			if(execnumber == 1){
				Interval_date	=	Interval_date + int_date;
			}
			//タスクは読み込みだけで、他も存在する
			else{
				Interval_date	=	Interval_date + int_date/execnumber;
			}			
		}
		//リスタートする
		Restart_date = System.currentTimeMillis();
		pause_date = 0;
	
	
	}
*/
	//ゲッター
	public long getEnd_date() {
		return end_date;
	}
	public long getInterval_date() {
		return Interval_date;
	}
	public long getStart_date() {
		return start_date;
	}
	public long getWait_date() {
		return wait_date;
	}	
	public long getAll_Interval_date() {
		return all_Interval_date;
	}


	public long getRestart_date() {
		return Restart_date;
	}
	
}
